--- php-8.4.18/ext/opcache/jit/ir/ir_cfg.c	2026-02-10 17:48:03.000000000 +0000
+++ php-8.4.20RC1/ext/opcache/jit/ir/ir_cfg.c	2026-04-01 04:35:36.008870324 +0000
@@ -5,6 +5,10 @@
  * Authors: Dmitry Stogov <dmitry@php.net>
  */
 
+#ifndef _GNU_SOURCE
+# define _GNU_SOURCE
+#endif
+
 #include "ir.h"
 #include "ir_private.h"
 
@@ -77,12 +81,86 @@
 	}
 }
 
+static void ir_remove_phis_inputs(ir_ctx *ctx, ir_use_list *use_list, int new_inputs_count, ir_bitset life_inputs)
+{
+	ir_ref i, j, n, k, *p, *q, use;
+	ir_insn *use_insn;
+
+	if (new_inputs_count == 1) {
+		for (k = use_list->count, p = q = &ctx->use_edges[use_list->refs]; k > 0; p++, k--) {
+			use = *p;
+			use_insn = &ctx->ir_base[use];
+			if (use_insn->op == IR_PHI) {
+				/* Convert PHI to COPY */
+				n = use_insn->inputs_count;
+				i = 2;
+				for (j = 2; j <= n; j++) {
+					ir_ref input = ir_insn_op(use_insn, j);
+
+					if (ir_bitset_in(life_inputs, j - 1)) {
+						use_insn->op1 = ir_insn_op(use_insn, j);
+					} else if (input > 0) {
+						ir_use_list_remove_one(ctx, input, use);
+					}
+				}
+				use_insn->op = IR_COPY;
+				use_insn->inputs_count = 1;
+				for (j = 2; j <= n; j++) {
+					ir_insn_set_op(use_insn, j, IR_UNUSED);
+				}
+				continue;
+			}
+
+			/*compact use list */
+			if (p != q){
+				*q = use;
+			}
+			q++;
+		}
+
+		if (p != q) {
+			use_list->count -= (p - q);
+			do {
+				*q = IR_UNUSED; /* clenu-op the removed tail */
+				q++;
+			} while (p != q);
+		}
+	} else {
+		for (k = use_list->count, p = &ctx->use_edges[use_list->refs]; k > 0; p++, k--) {
+			use = *p;
+			use_insn = &ctx->ir_base[use];
+			if (use_insn->op == IR_PHI) {
+				n = use_insn->inputs_count;
+				i = 2;
+				for (j = 2; j <= n; j++) {
+					ir_ref input = ir_insn_op(use_insn, j);
+
+					if (ir_bitset_in(life_inputs, j - 1)) {
+						IR_ASSERT(input);
+						if (i != j) {
+							ir_insn_set_op(use_insn, i, input);
+						}
+						i++;
+					} else if (input > 0) {
+						ir_use_list_remove_one(ctx, input, use);
+					}
+				}
+				use_insn->inputs_count = i - 1;
+				for (j = i; j <= n; j++) {
+					ir_insn_set_op(use_insn, j, IR_UNUSED);
+				}
+			}
+		}
+	}
+}
+
 static uint32_t IR_NEVER_INLINE ir_cfg_remove_dead_inputs(ir_ctx *ctx, uint32_t *_blocks, ir_block *blocks, uint32_t bb_count)
 {
 	uint32_t b, count = 0;
 	ir_block *bb = blocks + 1;
 	ir_insn *insn;
 	ir_ref i, j, n, *ops, input;
+	ir_bitset life_inputs = NULL;
 
 	for (b = 1; b <= bb_count; b++, bb++) {
 		bb->successors = count;
@@ -96,12 +174,27 @@
 			for (i = 1, j = 1; i <= n; i++) {
 				input = ops[i];
 				if (_blocks[input]) {
+					if (life_inputs) {
+						ir_bitset_incl(life_inputs, i);
+					}
 					if (i != j) {
 						ops[j] = ops[i];
 					}
 					j++;
-				} else if (input > 0) {
-					ir_use_list_remove_one(ctx, input, bb->start);
+				} else {
+					if (ctx->use_lists[bb->start].count > 1) {
+						/* Some inputs of this MERGE are deleted and we have to update the depended PHIs */
+						if (!life_inputs) {
+							int k;
+							life_inputs = ir_bitset_malloc(n + 1);
+							for (k = 1; k < i; k++) {
+								ir_bitset_incl(life_inputs, k);
+							}
+						}
+					}
+					IR_ASSERT(input > 0);
+					IR_ASSERT(ctx->use_lists[input].count == 1 && ctx->use_edges[ctx->use_lists[input].refs] == bb->start);
+					CLEAR_USES(input);
 				}
 			}
 			j--;
@@ -115,6 +208,11 @@
 				for (;j <= n; j++) {
 					ops[j] = IR_UNUSED;
 				}
+				if (life_inputs) {
+					ir_remove_phis_inputs(ctx, &ctx->use_lists[bb->start], insn->inputs_count, life_inputs);
+					ir_mem_free(life_inputs);
+					life_inputs = NULL;
+				}
 			}
 		}
 		count += bb->predecessors_count;
@@ -375,8 +473,7 @@
 
 static void ir_remove_merge_input(ir_ctx *ctx, ir_ref merge, ir_ref from)
 {
-	ir_ref i, j, n, k, *p, *q, use;
-	ir_insn *use_insn;
+	ir_ref i, j, n;
 	ir_use_list *use_list;
 	ir_bitset life_inputs;
 	ir_insn *insn = &ctx->ir_base[merge];
@@ -402,82 +499,17 @@
 	}
 	if (i == 1) {
 		insn->op = IR_BEGIN;
-		insn->inputs_count = 1;
-		use_list = &ctx->use_lists[merge];
-		if (use_list->count > 1) {
-			n++;
-			for (k = use_list->count, p = q = &ctx->use_edges[use_list->refs]; k > 0; p++, k--) {
-				use = *p;
-				use_insn = &ctx->ir_base[use];
-				if (use_insn->op == IR_PHI) {
-					/* Convert PHI to COPY */
-					i = 2;
-					for (j = 2; j <= n; j++) {
-						ir_ref input = ir_insn_op(use_insn, j);
-
-						if (ir_bitset_in(life_inputs, j - 1)) {
-							use_insn->op1 = ir_insn_op(use_insn, j);
-						} else if (input > 0) {
-							ir_use_list_remove_one(ctx, input, use);
-						}
-					}
-					use_insn->op = IR_COPY;
-					use_insn->inputs_count = 1;
-					for (j = 2; j <= n; j++) {
-						ir_insn_set_op(use_insn, j, IR_UNUSED);
-					}
-					continue;
-				}
-
-				/*compact use list */
-				if (p != q){
-					*q = use;
-				}
-				q++;
-			}
-
-			if (p != q) {
-				use_list->count -= (p - q);
-				do {
-					*q = IR_UNUSED; /* clenu-op the removed tail */
-					q++;
-				} while (p != q);
-			}
-		}
-	} else {
-		insn->inputs_count = i;
+	}
+	insn->inputs_count = i;
 
-		use_list = &ctx->use_lists[merge];
-		if (use_list->count > 1) {
-			n++;
-			for (k = use_list->count, p = &ctx->use_edges[use_list->refs]; k > 0; p++, k--) {
-				use = *p;
-				use_insn = &ctx->ir_base[use];
-				if (use_insn->op == IR_PHI) {
-					i = 2;
-					for (j = 2; j <= n; j++) {
-						ir_ref input = ir_insn_op(use_insn, j);
-
-						if (ir_bitset_in(life_inputs, j - 1)) {
-							IR_ASSERT(input);
-							if (i != j) {
-								ir_insn_set_op(use_insn, i, input);
-							}
-							i++;
-						} else if (input > 0) {
-							ir_use_list_remove_one(ctx, input, use);
-						}
-					}
-					use_insn->inputs_count = i - 1;
-					for (j = i; j <= n; j++) {
-						ir_insn_set_op(use_insn, j, IR_UNUSED);
-					}
-				}
-			}
-		}
+	use_list = &ctx->use_lists[merge];
+	if (use_list->count > 1) {
+		ir_remove_phis_inputs(ctx, use_list, i, life_inputs);
 	}
+
 	ir_mem_free(life_inputs);
-	ir_use_list_remove_all(ctx, from, merge);
+	IR_ASSERT(ctx->use_lists[from].count == 1 && ctx->use_edges[ctx->use_lists[from].refs] == merge);
+	CLEAR_USES(from);
 }
 
 /* CFG constructed after SCCP pass doesn't have unreachable BBs, otherwise they should be removed */
@@ -582,59 +614,64 @@
 	return 1;
 }
 
-static void compute_postnum(const ir_ctx *ctx, uint32_t *cur, uint32_t b)
-{
-	uint32_t i, *p;
-	ir_block *bb = &ctx->cfg_blocks[b];
-
-	if (bb->postnum != 0) {
-		return;
-	}
-
-	if (bb->successors_count) {
-		bb->postnum = -1; /* Marker for "currently visiting" */
-		p = ctx->cfg_edges + bb->successors;
-		i = bb->successors_count;
-		do {
-			compute_postnum(ctx, cur, *p);
-			p++;
-		} while (--i);
-	}
-	bb->postnum = (*cur)++;
-}
-
 /* Computes dominator tree using algorithm from "A Simple, Fast Dominance Algorithm" by
  * Cooper, Harvey and Kennedy. */
 static IR_NEVER_INLINE int ir_build_dominators_tree_slow(ir_ctx *ctx)
 {
-	uint32_t blocks_count, b, postnum;
+	uint32_t blocks_count, b, postnum, i;
 	ir_block *blocks, *bb;
 	uint32_t *edges;
+	uint32_t *rpo = ir_mem_malloc((ctx->cfg_blocks_count + 1) * sizeof(uint32_t));
 	bool changed;
 
 	blocks = ctx->cfg_blocks;
 	edges  = ctx->cfg_edges;
 	blocks_count = ctx->cfg_blocks_count;
 
-	/* Clear the dominators tree */
-	for (b = 0, bb = &blocks[0]; b <= blocks_count; b++, bb++) {
-		bb->idom = 0;
-		bb->dom_depth = 0;
-		bb->dom_child = 0;
-		bb->dom_next_child = 0;
-	}
-
 	ctx->flags2 &= ~IR_NO_LOOPS;
 
 	postnum = 1;
-	compute_postnum(ctx, &postnum, 1);
+	ir_worklist work;
+	ir_worklist_init(&work, ctx->cfg_blocks_count + 1);
+	ir_worklist_push(&work, 1);
+	IR_ASSERT(blocks[1].next_succ == 0);
+	while (ir_worklist_len(&work)) {
+next:
+		b = ir_worklist_peek(&work);
+		bb = &blocks[b];
+		uint32_t n = bb->successors_count - bb->next_succ;
+		if (n) {
+			uint32_t *p = edges + bb->successors + bb->next_succ;
+			for (; n > 0; p++, n--) {
+				uint32_t succ = *p;
+				if (ir_worklist_push(&work, succ)) {
+					bb->next_succ = bb->successors_count - n + 1;
+					IR_ASSERT(blocks[succ].next_succ == 0);
+					goto next;
+				}
+			}
+		}
+
+		/* Start from bb->idom calculated by the fast dominators algorithm */
+		// bb->idom = 0;
+		bb->next_succ = 0;
+		rpo[postnum] = b;
+		bb->postnum = postnum++;
+		ir_worklist_pop(&work);
+	}
+	ir_worklist_free(&work);
+
+	IR_ASSERT(rpo[blocks_count] == 1);
 
 	/* Find immediate dominators by iterative fixed-point algorithm */
 	blocks[1].idom = 1;
 	do {
 		changed = 0;
+
 		/* Iterating in Reverse Post Order */
-		for (b = 2, bb = &blocks[2]; b <= blocks_count; b++, bb++) {
+		for (i = blocks_count - 1; i > 0; i--) {
+			b = rpo[i];
+			bb = &blocks[b];
 			IR_ASSERT(!(bb->flags & IR_BB_UNREACHABLE));
 			IR_ASSERT(bb->predecessors_count > 0);
 			if (bb->predecessors_count == 1) {
@@ -687,6 +724,8 @@
 		}
 	} while (changed);
 
+	ir_mem_free(rpo);
+
 	/* Build dominators tree */
 	blocks[1].idom = 0;
 	blocks[1].dom_depth = 0;
@@ -740,7 +779,7 @@
 	blocks[1].idom = 1;
 	blocks[1].dom_depth = 0;
 
-	/* Iterating in Reverse Post Order */
+	/* Iterating in Reverse Post Order (relay on existing BB order and fall-back to slow algorithm) */
 	for (b = 2, bb = &blocks[2]; b <= blocks_count; b++, bb++) {
 		IR_ASSERT(!(bb->flags & IR_BB_UNREACHABLE));
 		IR_ASSERT(bb->predecessors_count > 0);
@@ -752,8 +791,8 @@
 		if (UNEXPECTED(idom >= b)) {
 			/* In rare cases, LOOP_BEGIN.op1 may be a back-edge. Skip back-edges. */
 			ctx->flags2 &= ~IR_NO_LOOPS;
-//			IR_ASSERT(k > 1 && "Wrong blocks order: BB is before its single predecessor");
 			if (UNEXPECTED(k <= 1)) {
+				// IR_ASSERT(k > 1 && "Wrong blocks order: BB is before its single predecessor");
 slow_case:
 				ir_list_free(&worklist);
 				return ir_build_dominators_tree_slow(ctx);
@@ -767,6 +806,7 @@
 					break;
 				}
 				if (UNEXPECTED(k == 0)) {
+					// IR_ASSERT(0 && "Wrong blocks order: BB is before all its predecessors");
 					goto slow_case;
 				}
 				ir_list_push(&worklist, idom);
@@ -799,13 +839,6 @@
 		bb->dom_depth = idom_bb->dom_depth + 1;
 	}
 
-	/* Construct children lists sorted by block number */
-	for (b = blocks_count, bb = &blocks[b]; b >= 2; b--, bb--) {
-		ir_block *idom_bb = &blocks[bb->idom];
-		bb->dom_next_child = idom_bb->dom_child;
-		idom_bb->dom_child = b;
-	}
-
 	blocks[1].idom = 0;
 
 	if (ir_list_len(&worklist) != 0) {
@@ -843,10 +876,18 @@
 
 		if (UNEXPECTED(!complete)) {
 			ir_list_free(&worklist);
+			// TODO: this algorithm may be incorrect. Prove and/or switch to ir_build_dominators_tree_slow() ???
 			return ir_build_dominators_tree_iterative(ctx);
 		}
 	}
 
+	/* Construct children lists sorted by block number */
+	for (b = blocks_count, bb = &blocks[b]; b >= 2; b--, bb--) {
+		ir_block *idom_bb = &blocks[bb->idom];
+		bb->dom_next_child = idom_bb->dom_child;
+		idom_bb->dom_child = b;
+	}
+
 	ir_list_free(&worklist);
 
 	return 1;
@@ -867,8 +908,6 @@
 	/* Clear the dominators tree, but keep already found dominators */
 	for (b = 0, bb = &blocks[0]; b <= blocks_count; b++, bb++) {
 		bb->dom_depth = 0;
-		bb->dom_child = 0;
-		bb->dom_next_child = 0;
 	}
 
 	/* Find immediate dominators by iterative fixed-point algorithm */
@@ -886,20 +925,20 @@
 			if (blocks[idom].idom == 0) {
 				while (1) {
 					k--;
+					if (UNEXPECTED(k == 0)) break;
 					p++;
 					idom = *p;
 					if (blocks[idom].idom > 0) {
 						break;
 					}
-					IR_ASSERT(k > 0);
 				}
+				if (UNEXPECTED(k == 0)) continue;
 			}
 			IR_ASSERT(k != 0);
 			while (--k > 0) {
 				uint32_t pred_b = *(++p);
 
 				if (blocks[pred_b].idom > 0) {
-					IR_ASSERT(blocks[pred_b].idom > 0);
 					while (idom != pred_b) {
 						while (pred_b > idom) {
 							pred_b = blocks[pred_b].idom;
@@ -949,10 +988,107 @@
 	return b1 == b2;
 }
 
+/* Identify loops. See Sreedhar et al, "Identifying Loops Using DJ Graphs" and
+ * G. Ramalingam "Identifying Loops In Almost Linear Time". */
+
+#define ENTRY_TIME(b) times[(b) * 2]
+#define EXIT_TIME(b)  times[(b) * 2 + 1]
+
+static IR_NEVER_INLINE void ir_collect_irreducible_loops(ir_ctx *ctx, uint32_t *times, ir_worklist *work, ir_list *list)
+{
+	ir_block *blocks = ctx->cfg_blocks;
+	uint32_t *edges = ctx->cfg_edges;
+
+	IR_ASSERT(ir_list_len(list) != 0);
+	if (ir_list_len(list) > 1) {
+		/* Sort list to process irreducible loops in DFS order (insertion sort) */
+		ir_ref *a = list->a.refs;
+		uint32_t n = ir_list_len(list);
+		uint32_t i = 1;
+		while (i < n) {
+			uint32_t j = i;
+			while (j > 0 && ENTRY_TIME(a[j-1]) > ENTRY_TIME(a[j])) {
+				ir_ref tmp = a[j];
+				a[j] = a[j-1];
+				a[j-1] = tmp;
+				j--;
+			}
+			i++;
+		}
+	}
+	while (ir_list_len(list)) {
+		uint32_t hdr = ir_list_pop(list);
+		ir_block *bb = &blocks[hdr];
+
+		IR_ASSERT(bb->flags & IR_BB_IRREDUCIBLE_LOOP);
+		IR_ASSERT(!bb->loop_depth);
+		if (!bb->loop_depth) {
+			/* process irreducible loop */
+
+			bb->flags |= IR_BB_LOOP_HEADER;
+			bb->loop_depth = 1;
+			if (ctx->ir_base[bb->start].op == IR_MERGE) {
+				ctx->ir_base[bb->start].op = IR_LOOP_BEGIN;
+			}
+
+			/* find the closing edge(s) of the irreucible loop */
+			IR_ASSERT(bb->predecessors_count > 1);
+			IR_ASSERT(ir_worklist_len(work) == 0);
+			ir_bitset_clear(work->visited, ir_bitset_len(ir_worklist_capasity(work)));
+			ir_bitset_incl(work->visited, hdr);
+
+			uint32_t *p = &edges[bb->predecessors];
+			uint32_t n = bb->predecessors_count;
+			do {
+				uint32_t pred = *p;
+				if (ENTRY_TIME(pred) > ENTRY_TIME(hdr) && EXIT_TIME(pred) < EXIT_TIME(hdr)) {
+					ir_worklist_push(work, pred);
+				}
+				p++;
+			} while (--n);
+
+			/* collect members of the irreducible loop */
+			while (ir_worklist_len(work)) {
+				uint32_t b = ir_worklist_pop(work);
+
+				bb = &blocks[b];
+				if (!bb->loop_header) {
+					bb->loop_header = hdr;
+				}
+
+				uint32_t *p = &edges[bb->predecessors];
+				uint32_t n = bb->predecessors_count;
+
+				for (; n > 0; p++, n--) {
+					uint32_t pred = *p;
+					if (!ir_bitset_in(work->visited, pred)) {
+						if (blocks[pred].loop_header) {
+							if (blocks[pred].loop_header == b) continue;
+							do {
+								pred = blocks[pred].loop_header;
+							} while (blocks[pred].loop_header > 0);
+						}
+						if (ENTRY_TIME(pred) > ENTRY_TIME(hdr) && EXIT_TIME(pred) < EXIT_TIME(hdr)) {
+							/* "pred" is a descendant of "hdr" */
+								ir_worklist_push(work, pred);
+						} else if (bb->predecessors_count > 1) {
+							/* another entry to the irreducible loop */
+							bb->flags |= IR_BB_IRREDUCIBLE_LOOP;
+							if (ctx->ir_base[bb->start].op == IR_MERGE) {
+								ctx->ir_base[bb->start].op = IR_LOOP_BEGIN;
+							}
+						}
+					}
+				}
+			}
+		}
+	}
+}
+
 int ir_find_loops(ir_ctx *ctx)
 {
-	uint32_t b, j, n, count;
-	uint32_t *entry_times, *exit_times, *sorted_blocks, time = 1;
+	uint32_t b, j, n;
+	uint32_t *times, *sorted_blocks, time = 1;
 	ir_block *blocks = ctx->cfg_blocks;
 	uint32_t *edges = ctx->cfg_edges;
 	ir_worklist work;
@@ -961,52 +1097,44 @@
 		return 1;
 	}
 
-	/* We don't materialize the DJ spanning tree explicitly, as we are only interested in ancestor
-	 * queries. These are implemented by checking entry/exit times of the DFS search. */
+	/* Compute entry/exit times for the CFG DFS spanning tree to perform ancestor and back-edge queries. */
 	ir_worklist_init(&work, ctx->cfg_blocks_count + 1);
-	entry_times = ir_mem_malloc((ctx->cfg_blocks_count + 1) * 3 * sizeof(uint32_t));
-	exit_times = entry_times + ctx->cfg_blocks_count + 1;
-	sorted_blocks = exit_times + ctx->cfg_blocks_count + 1;
-
-	memset(entry_times, 0, (ctx->cfg_blocks_count + 1) * sizeof(uint32_t));
+	times = ir_mem_malloc((ctx->cfg_blocks_count + 1) * 3 * sizeof(uint32_t));
+	sorted_blocks = times + (ctx->cfg_blocks_count + 1) * 2;
 
+	ir_bitset visited = ir_bitset_malloc(ctx->cfg_blocks_count + 1);
 	ir_worklist_push(&work, 1);
 	while (ir_worklist_len(&work)) {
-		ir_block *bb;
-		int child;
-
 next:
 		b = ir_worklist_peek(&work);
-		if (!entry_times[b]) {
-			entry_times[b] = time++;
-		}
+		ir_block *bb = &blocks[b];
 
-		/* Visit blocks immediately dominated by "b". */
-		bb = &blocks[b];
-		for (child = bb->dom_child; child > 0; child = blocks[child].dom_next_child) {
-			if (ir_worklist_push(&work, child)) {
-				goto next;
-			}
+		if (!ir_bitset_in(visited, b)) {
+			ir_bitset_incl(visited, b);
+			ENTRY_TIME(b) = time++;
 		}
 
-		/* Visit join edges. */
-		if (bb->successors_count) {
-			uint32_t *p = edges + bb->successors;
-			for (j = 0; j < bb->successors_count; j++, p++) {
+		uint32_t n = bb->successors_count - bb->next_succ;
+		if (n) {
+			uint32_t *p = edges + bb->successors + bb->next_succ;
+			for (; n > 0; p++, n--) {
 				uint32_t succ = *p;
-
-				if (blocks[succ].idom == b) {
-					continue;
-				} else if (ir_worklist_push(&work, succ)) {
+				if (ir_worklist_push(&work, succ)) {
+					bb->next_succ = bb->successors_count - n + 1;
+					IR_ASSERT(blocks[succ].next_succ == 0);
 					goto next;
 				}
 			}
 		}
-		exit_times[b] = time++;
+
+		bb->next_succ = 0;
+		EXIT_TIME(b) = time++;
 		ir_worklist_pop(&work);
 	}
+	ir_mem_free(visited);
 
 	/* Sort blocks by level, which is the opposite order in which we want to process them */
+	/* (Breadth First Search using "sorted_blocks" as a queue) */
 	sorted_blocks[1] = 1;
 	j = 1;
 	n = 2;
@@ -1020,127 +1148,62 @@
 			}
 		}
 	}
-	count = n;
+	IR_ASSERT(n == ctx->cfg_blocks_count + 1);
 
-	/* Identify loops. See Sreedhar et al, "Identifying Loops Using DJ Graphs". */
+#if IR_DEBUG
 	uint32_t prev_dom_depth = blocks[sorted_blocks[n - 1]].dom_depth;
-	uint32_t prev_irreducible = 0;
+#endif
+	uint32_t irreducible_depth = 0;
+	ir_list irreducible_list = {0};
+
 	while (n > 1) {
 		b = sorted_blocks[--n];
 		ir_block *bb = &blocks[b];
 
 		IR_ASSERT(bb->dom_depth <= prev_dom_depth);
-		if (UNEXPECTED(prev_irreducible) && bb->dom_depth != prev_dom_depth) {
-			/* process delyed irreducible loops */
-			do {
-				b = sorted_blocks[prev_irreducible];
-				bb = &blocks[b];
-				if ((bb->flags & IR_BB_IRREDUCIBLE_LOOP) && !bb->loop_depth) {
-					/* process irreducible loop */
-					uint32_t hdr = b;
-
-					bb->loop_depth = 1;
-					if (ctx->ir_base[bb->start].op == IR_MERGE) {
-						ctx->ir_base[bb->start].op = IR_LOOP_BEGIN;
-					}
 
-					/* find the closing edge(s) of the irreucible loop */
-					IR_ASSERT(bb->predecessors_count > 1);
-					uint32_t *p = &edges[bb->predecessors];
-					j = bb->predecessors_count;
-					do {
-						uint32_t pred = *p;
-
-						if (entry_times[pred] > entry_times[b] && exit_times[pred] < exit_times[b]) {
-							if (!ir_worklist_len(&work)) {
-								ir_bitset_clear(work.visited, ir_bitset_len(ir_worklist_capasity(&work)));
-							}
-							blocks[pred].loop_header = 0; /* support for merged loops */
-							ir_worklist_push(&work, pred);
-						}
-						p++;
-					} while (--j);
-					if (ir_worklist_len(&work) == 0) continue;
-
-					/* collect members of the irreducible loop */
-					while (ir_worklist_len(&work)) {
-						b = ir_worklist_pop(&work);
-						if (b != hdr) {
-							ir_block *bb = &blocks[b];
-							bb->loop_header = hdr;
-							if (bb->predecessors_count) {
-								uint32_t *p = &edges[bb->predecessors];
-								uint32_t n = bb->predecessors_count;
-								do {
-									uint32_t pred = *p;
-									while (blocks[pred].loop_header > 0) {
-										pred = blocks[pred].loop_header;
-									}
-									if (pred != hdr) {
-										if (entry_times[pred] > entry_times[hdr] && exit_times[pred] < exit_times[hdr]) {
-											/* "pred" is a descendant of "hdr" */
-											ir_worklist_push(&work, pred);
-										} else {
-											/* another entry to the irreducible loop */
-											bb->flags |= IR_BB_IRREDUCIBLE_LOOP;
-											if (ctx->ir_base[bb->start].op == IR_MERGE) {
-												ctx->ir_base[bb->start].op = IR_LOOP_BEGIN;
-											}
-										}
-									}
-									p++;
-								} while (--n);
-							}
-						}
-					}
-				}
-			} while (--prev_irreducible != n);
-			prev_irreducible = 0;
-			b = sorted_blocks[n];
-			bb = &blocks[b];
+		if (UNEXPECTED(bb->dom_depth < irreducible_depth)) {
+			ir_collect_irreducible_loops(ctx, times, &work, &irreducible_list);
+			irreducible_depth = 0;
 		}
 
 		if (bb->predecessors_count > 1) {
 			bool irreducible = 0;
+			uint32_t b_entry_time = ENTRY_TIME(b);
+			uint32_t b_exit_time = EXIT_TIME(b);
 			uint32_t *p = &edges[bb->predecessors];
 
-			j = bb->predecessors_count;
-			do {
+			for (j = bb->predecessors_count; j > 0; p++, j--) {
 				uint32_t pred = *p;
 
-				/* A join edge is one for which the predecessor does not
-				   immediately dominate the successor.  */
-				if (bb->idom != pred) {
-					/* In a loop back-edge (back-join edge), the successor dominates
-					   the predecessor.  */
+				/* Check back-edges */
+				if (ENTRY_TIME(pred) >= b_entry_time && EXIT_TIME(pred) <= b_exit_time) {
 					if (ir_dominates(blocks, b, pred)) {
+						/* In a loop back-edge (back-join edge), the successor dominates
+						   the predecessor.  */
 						if (!ir_worklist_len(&work)) {
 							ir_bitset_clear(work.visited, ir_bitset_len(ir_worklist_capasity(&work)));
 						}
-						blocks[pred].loop_header = 0; /* support for merged loops */
 						ir_worklist_push(&work, pred);
 					} else {
-						/* Otherwise it's a cross-join edge.  See if it's a branch
-						   to an ancestor on the DJ spanning tree.  */
-						if (entry_times[pred] > entry_times[b] && exit_times[pred] < exit_times[b]) {
-							irreducible = 1;
-							break;
-						}
+						/* Otherwise it's a back-edge of irreducible loop. */
+						irreducible = 1;
+						break;
 					}
 				}
-				p++;
-			} while (--j);
+			}
 
 			if (UNEXPECTED(irreducible)) {
-				bb->flags |= IR_BB_LOOP_HEADER | IR_BB_IRREDUCIBLE_LOOP;
+				bb->flags |= IR_BB_IRREDUCIBLE_LOOP;
 				ctx->flags2 |= IR_CFG_HAS_LOOPS | IR_IRREDUCIBLE_CFG;
-				/* Remember the position of the first irreducible loop to process all the irreducible loops
-				 * after the reducible loops with the same dominator tree depth
+				/* Delay processing of all irreducible loops
+				 * after all reducible loops with the same dominator tree depth
 				 */
-				if (!prev_irreducible) {
-					prev_irreducible = n;
-					prev_dom_depth = bb->dom_depth;
+				irreducible_depth = bb->dom_depth;
+				if (!ir_list_capasity(&irreducible_list)) {
+					ir_list_init(&irreducible_list, 16);
 				}
+				ir_list_push(&irreducible_list, b);
 				ir_list_clear(&work.l);
 			} else if (ir_worklist_len(&work)) {
 				/* collect members of the reducible loop */
@@ -1152,35 +1215,48 @@
 				if (ctx->ir_base[bb->start].op == IR_MERGE) {
 					ctx->ir_base[bb->start].op = IR_LOOP_BEGIN;
 				}
+				ir_bitset_incl(work.visited, hdr);
 				while (ir_worklist_len(&work)) {
 					b = ir_worklist_pop(&work);
 					if (b != hdr) {
 						ir_block *bb = &blocks[b];
-						bb->loop_header = hdr;
-						if (bb->predecessors_count) {
-							uint32_t *p = &edges[bb->predecessors];
-							uint32_t n = bb->predecessors_count;
-							do {
-								uint32_t pred = *p;
-								while (blocks[pred].loop_header > 0) {
-									pred = blocks[pred].loop_header;
-								}
-								if (pred != hdr) {
+
+						if (!bb->loop_header) {
+							bb->loop_header = hdr;
+						}
+
+						uint32_t *p = &edges[bb->predecessors];
+						uint32_t n = bb->predecessors_count;
+						for (; n > 0; p++, n--) {
+							uint32_t pred = *p;
+							if (!ir_bitset_in(work.visited, pred)) {
+								if (blocks[pred].loop_header) {
+									if (blocks[pred].loop_header == b) continue;
+									do {
+										pred = blocks[pred].loop_header;
+									} while (blocks[pred].loop_header > 0);
 									ir_worklist_push(&work, pred);
+								} else {
+									ir_bitset_incl(work.visited, pred);
+									ir_list_push_unchecked(&work.l, pred);
 								}
-								p++;
-							} while (--n);
+							}
 						}
 					}
 				}
 			}
 		}
 	}
-	IR_ASSERT(!prev_irreducible);
+
+	IR_ASSERT(!irreducible_depth);
+	if (ir_list_capasity(&irreducible_list)) {
+		ir_list_free(&irreducible_list);
+	}
 
 	if (ctx->flags2 & IR_CFG_HAS_LOOPS) {
-		for (n = 1; n < count; n++) {
-			b = sorted_blocks[n];
+		n = ctx->cfg_blocks_count + 1;
+		for (j = 1; j < n; j++) {
+			b = sorted_blocks[j];
 			ir_block *bb = &blocks[b];
 			if (bb->loop_header > 0) {
 				ir_block *loop = &blocks[bb->loop_header];
@@ -1211,7 +1287,7 @@
 		}
 	}
 
-	ir_mem_free(entry_times);
+	ir_mem_free(times);
 	ir_worklist_free(&work);
 
 	return 1;
@@ -1411,6 +1487,19 @@
 		}
 	}
 }
+
+static bool ir_is_merged_loop_back_edge(ir_ctx *ctx, uint32_t hdr, uint32_t b)
+{
+	if (ctx->cfg_blocks[hdr].flags & IR_BB_LOOP_HEADER) {
+		uint32_t loop_depth = ctx->cfg_blocks[hdr].loop_depth;
+
+		while (ctx->cfg_blocks[b].loop_depth > loop_depth) {
+			b = ctx->cfg_blocks[b].loop_header;
+		}
+		return b == hdr;
+	}
+	return 0;
+}
 #endif
 
 static int ir_schedule_blocks_bottom_up(ir_ctx *ctx)
@@ -1467,7 +1556,8 @@
 					}
 				} else if (b != predecessor && ctx->cfg_blocks[predecessor].loop_header != b) {
 					/* not a loop back-edge */
-					IR_ASSERT(b == predecessor || ctx->cfg_blocks[predecessor].loop_header == b);
+					IR_ASSERT(b == predecessor || ctx->cfg_blocks[predecessor].loop_header == b ||
+						ir_is_merged_loop_back_edge(ctx, b, predecessor));
 				}
 			}
 		}
diff '--color=auto' -Naur php-8.4.18/ext/opcache/jit/ir/ir_dump.c php-8.4.20RC1/ext/opcache/jit/ir/ir_dump.c
--- php-8.4.18/ext/opcache/jit/ir/ir_dump.c	2026-02-10 17:48:03.000000000 +0000
+++ php-8.4.20RC1/ext/opcache/jit/ir/ir_dump.c	2026-04-01 04:35:36.009148690 +0000
@@ -60,7 +60,7 @@
 	}
 }
 
-void ir_dump_dot(const ir_ctx *ctx, const char *name, FILE *f)
+void ir_dump_dot(const ir_ctx *ctx, const char *name, const char *comments, FILE *f)
 {
 	int DATA_WEIGHT    = 0;
 	int CONTROL_WEIGHT = 5;
@@ -70,6 +70,13 @@
 	uint32_t flags;
 
 	fprintf(f, "digraph %s {\n", name);
+	fprintf(f, "\tlabelloc=t;\n");
+	fprintf(f, "\tlabel=\"");
+	ir_print_func_proto(ctx, name, 0, f);
+	if (comments) {
+		fprintf(f, " # %s", comments);
+	}
+	fprintf(f, "\"\n");
 	fprintf(f, "\trankdir=TB;\n");
 	for (i = 1 - ctx->consts_count, insn = ctx->ir_base + i; i < IR_UNUSED; i++, insn++) {
 		fprintf(f, "\tc%d [label=\"C%d: CONST %s(", -i, -i, ir_type_name[insn->type]);
diff '--color=auto' -Naur php-8.4.18/ext/opcache/jit/ir/ir_emit.c php-8.4.20RC1/ext/opcache/jit/ir/ir_emit.c
--- php-8.4.18/ext/opcache/jit/ir/ir_emit.c	2026-02-10 17:48:03.000000000 +0000
+++ php-8.4.20RC1/ext/opcache/jit/ir/ir_emit.c	2026-04-01 04:35:36.009261042 +0000
@@ -5,6 +5,10 @@
  * Authors: Dmitry Stogov <dmitry@php.net>
  */
 
+#ifndef _GNU_SOURCE
+# define _GNU_SOURCE
+#endif
+
 #include "ir.h"
 
 #if defined(IR_TARGET_X86) || defined(IR_TARGET_X64)
@@ -971,7 +975,7 @@
 	return 1;
 }
 
-int32_t ir_get_spill_slot_offset(ir_ctx *ctx, ir_ref ref)
+int32_t ir_get_spill_slot_offset(const ir_ctx *ctx, ir_ref ref)
 {
 	int32_t offset;
 
diff '--color=auto' -Naur php-8.4.18/ext/opcache/jit/ir/ir_fold.h php-8.4.20RC1/ext/opcache/jit/ir/ir_fold.h
--- php-8.4.18/ext/opcache/jit/ir/ir_fold.h	2026-02-10 17:48:03.000000000 +0000
+++ php-8.4.20RC1/ext/opcache/jit/ir/ir_fold.h	2026-04-01 04:35:36.009413630 +0000
@@ -3439,5 +3439,84 @@
 	if (op2 == op3) {
 		IR_FOLD_COPY(op2);
 	}
+
+	if (op1_insn->type == IR_BOOL) {
+		if (op2 == IR_TRUE) {
+			if (op3 == IR_FALSE) {
+				/* a ? true : false => a */
+				IR_FOLD_COPY(op1);
+			} else {
+				/* a ? true : b => a | b */
+				opt = IR_OPT(IR_OR, IR_BOOL);
+				op2 = op3;
+				op3 = IR_UNUSED;
+				IR_FOLD_RESTART;
+			}
+		} else if (op3 == IR_FALSE) {
+			/* a ? b : false => a & b */
+			opt = IR_OPT(IR_AND, IR_BOOL);
+			op3 = IR_UNUSED;
+			IR_FOLD_RESTART;
+		} else if (op2 == IR_FALSE) {
+			if (op3 == IR_TRUE) {
+				/* a ? flase : true => !a */
+				opt = IR_OPT(IR_NOT, IR_BOOL);
+				op2 = IR_UNUSED;
+				op3 = IR_UNUSED;
+				IR_FOLD_RESTART;
+			}
+		} else if (IR_IS_TYPE_INT(IR_OPT_TYPE(opt))
+		 && IR_IS_CONST_REF(op2)
+		 && IR_IS_CONST_REF(op3)
+		 && op2_insn->val.u64 == 1
+		 && op3_insn->val.u64 == 0) {
+			if (ir_type_size[IR_OPT_TYPE(opt)] > 1) {
+				/* a ? 1 : 0 => ZEXT(a) */
+				opt = IR_OPT(IR_ZEXT, IR_OPT_TYPE(opt));
+			} else {
+				/* a ? 1 : 0 => BITCAST(a) */
+				opt = IR_OPT(IR_BITCAST, IR_OPT_TYPE(opt));
+			}
+			op2 = IR_UNUSED;
+			op3 = IR_UNUSED;
+			IR_FOLD_RESTART;
+	   }
+	} else if (IR_IS_TYPE_INT(op1_insn->type)) {
+		if (op2 == IR_TRUE) {
+			if (op3 == IR_FALSE) {
+				opt = IR_OPT(IR_NE, IR_BOOL);
+				val.u64 = 0;
+				op2 = ir_const(ctx, val, op1_insn->type);
+				op3 = IR_UNUSED;
+				IR_FOLD_RESTART;
+			}
+		} else if (op2 == IR_FALSE) {
+			if (op3 == IR_TRUE) {
+				opt = IR_OPT(IR_EQ, IR_BOOL);
+				val.u64 = 0;
+				op2 = ir_const(ctx, val, op1_insn->type);
+				op3 = IR_UNUSED;
+				IR_FOLD_RESTART;
+			}
+		}
+	}
+
+	if (op1_insn->op == IR_NE) {
+		if (IR_IS_CONST_REF(op1_insn->op2)
+		 && IR_IS_TYPE_INT(ctx->ir_base[op1_insn->op2].type)
+		 && ctx->ir_base[op1_insn->op2].val.u64 == 0) {
+			op1 = op1_insn->op1;
+			IR_FOLD_RESTART;
+		}
+	} else if (op1_insn->op == IR_EQ) {
+		if (IR_IS_CONST_REF(op1_insn->op2)
+		 && IR_IS_TYPE_INT(ctx->ir_base[op1_insn->op2].type)
+		 && ctx->ir_base[op1_insn->op2].val.u64 == 0) {
+			op1 = op1_insn->op1;
+			SWAP_REFS(op2, op3);
+			IR_FOLD_RESTART;
+		}
+	}
+
 	IR_FOLD_NEXT;
 }
diff '--color=auto' -Naur php-8.4.18/ext/opcache/jit/ir/ir_gcm.c php-8.4.20RC1/ext/opcache/jit/ir/ir_gcm.c
